"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var Subject_1 = require("rxjs/Subject");
var components_1 = require("../../components");
/*
  Generated class for the DatePickerProvider provider.

  See https://angular.io/guide/dependency-injection for more info on providers
  and Angular DI.
*/
var DatePickerProvider = (function () {
    function DatePickerProvider() {
    }
    DatePickerProvider.prototype.showCalendar = function (modalCtrl, datePickerOption) {
        var _this = this;
        this.onDateSelected = new Subject_1.Subject();
        this.onDismiss = new Subject_1.Subject();
        this.onUnsubscribe = new Subject_1.Subject();
        var calendarModal = modalCtrl.create(components_1.DatePicker, datePickerOption);
        calendarModal.present();
        this.onDismiss
            .takeUntil(this.onUnsubscribe)
            .subscribe(function (result) { return _this.handleCalendarDismissed(result, calendarModal); });
        return this.onDateSelected.asObservable();
    };
    DatePickerProvider.prototype.handleCalendarDismissed = function (result, calendarModal) {
        if (result === 'dismiss') {
            calendarModal.dismiss();
        }
        else if (result instanceof Date) {
            this.onDateSelected.next(result);
            calendarModal.dismiss();
        }
    };
    DatePickerProvider.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    DatePickerProvider.ctorParameters = function () { return []; };
    return DatePickerProvider;
}());
exports.DatePickerProvider = DatePickerProvider;
//# sourceMappingURL=date-picker.js.map